/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jpolyliner2;

import java.awt.Graphics;

import java.awt.image.BufferedImage;
import javax.swing.JPanel;

import polyliner.domain.impl.facade.scalesnap.ScaleSnapGrid;
import polyliner.domain.utilities.draw.DrawPointListener;
import polyliner.domain.utilities.draw.DrawPointManager;
import polyliner.domain.utilities.draw.DrawPolylineListener;
import polyliner.domain.utilities.draw.DrawPolylineManager;

/**
 *
 * @author dario
 */
public class ImageDrawComponent  extends  JPanel implements DrawPointListener, DrawPolylineListener {

    private BufferedImage img;
    private DrawPointManager pts;
    private DrawPolylineManager poli;
    private ScaleSnapGrid grid;
    
    public ImageDrawComponent(BufferedImage img, DrawPointManager pts,DrawPolylineManager poli, ScaleSnapGrid grid) {
        this.img = img;
        this.grid = grid;
        this.poli = poli;
        this.pts = pts;
        super.setSize(img.getWidth(),img.getHeight());
        this.pts.addDrawPointListener(this);
        this.poli.addDrawPolylineListener(this);
    }
    
    @Override
    public void paint(Graphics g) {
       super.paint(g);
       double sf = this.grid.getScale();
       g.drawImage(img,0,0,(int) (this.img.getWidth() * sf),(int) (this.img.getHeight() * sf),null);
       this.pts.paint(g);
       this.poli.paint(g);
      
    }

    public void drawStateChanged() {
        
        this.getParent().repaint();
    }

    
}
