/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jpolyliner2.utils;

import java.awt.event.MouseEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import polyliner.domain.exceptions.PointNotFoundException;
import polyliner.domain.impl.facade.scalesnap.ScaleSnapGrid;
import polyliner.domain.interfaces.Point;
import polyliner.domain.interfaces.Polyline;
import polyliner.domain.utilities.draw.DrawPointManager;
import polyliner.domain.utilities.draw.DrawPolylineManager;

/**
 *
 * @author dario
 */
public class CreateRemoveAction extends NoOpAction {

    private Point currentPoint;
    
    public CreateRemoveAction(ScaleSnapGrid grid, DrawPointManager pointMgr, DrawPolylineManager polyMgr) {
        super(grid,pointMgr,polyMgr);
        this.description = "Left click to select points - Hold it to drag a point; Middle click to delete points; Right click to add points";
    }

    @Override
    public void dragMouse(MouseEvent e, Polyline current) {
        if(this.currentPoint != null)
            this.currentPoint.setCoords(e.getX(), e.getY());
    }

    @Override
    public void leftMouseButtonClick(MouseEvent e, Polyline current) {
        Point p = this.pointMgr.selected(e.getX(), e.getY());
        if(p != null)
            p.select();
        if(currentPoint != null && p != currentPoint) {
            this.currentPoint.deselect();
        }
        this.currentPoint = p;
    }

    @Override
    public void middleMouseButtonClick(MouseEvent e, Polyline current) {
        try {
            Point p = this.pointMgr.selected(e.getX(), e.getY());
            if (p != null) {
                this.grid.removePoint(p.getId());
            }
        } catch (PointNotFoundException ex) {
            Logger.getLogger(CreateRemoveAction.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    @Override
    public void rightMouseButtonClick(MouseEvent e, Polyline current) {
        Point p = this.grid.addPoint(e.getX(), e.getY());
        if(p != null)
            p.select();
        if(currentPoint != null && p != currentPoint) {
            this.currentPoint.deselect();
        }
        this.currentPoint = p;
    }

    @Override
    public void clear() {
        if (currentPoint != null) {
                currentPoint.deselect();
        }
        this.currentPoint = null;
    }

    
}
