/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jpolyliner2.utils;

import java.awt.event.MouseEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import polyliner.domain.exceptions.PointNotFoundException;
import polyliner.domain.impl.facade.scalesnap.ScaleSnapGrid;
import polyliner.domain.interfaces.Point;
import polyliner.domain.interfaces.Polyline;
import polyliner.domain.utilities.draw.DrawPointManager;
import polyliner.domain.utilities.draw.DrawPolylineManager;

/**
 *
 * @author dario
 */
public class InsertPolyPointsOnClickAction extends NoOpAction {

    public InsertPolyPointsOnClickAction(ScaleSnapGrid grid, DrawPointManager pointMgr, DrawPolylineManager polyMgr) {
        super(grid, pointMgr, polyMgr);
        this.description = "Left click to create and append points to selected polyline; Right click to append the selected point to the selected polyline; Middle click to create and attach a point in the middle of a line";
    }

    @Override
    public void dragMouse(MouseEvent e, Polyline current) {
        //
    }

    @Override
    public void leftMouseButtonClick(MouseEvent e, Polyline current) {
        if(current != null) {
            Point p = this.grid.addPoint(e.getX(), e.getY());
            current.addPoint(p);
        }
    }

    @Override
    public void middleMouseButtonClick(MouseEvent e, Polyline current) {
        if(current != null) {
            try {
                Point p = this.grid.addPoint(e.getX(), e.getY());
                int index = current.insertPoint(p);
                if (index == -1) {
                    this.grid.removePoint(p.getId());
                }
            } catch (PointNotFoundException ex) {
                Logger.getLogger(InsertPolyPointsOnClickAction.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    @Override
    public void rightMouseButtonClick(MouseEvent e, Polyline current) {
        if(current != null) {
            Point p = this.pointMgr.selected(e.getX(), e.getY());
            if(p != null)
                current.addPoint(p);
        }
    }
}
